<template>
  <div class="container">
    <Disclosure as="nav" class="bg-gray-800" v-slot="{ open }">
      <div class="max-w-7xl mx-auto px-2 sm:px-6 lg:px-8">
        <div class="relative flex items-center justify-between h-16">
          <div class="absolute inset-y-0 left-0 flex items-center sm:hidden">
            <!-- Mobile menu button-->
            <DisclosureButton
              class="inline-flex items-center justify-center p-2 rounded-md text-gray-400 hover:text-white hover:bg-gray-700 focus:outline-none focus:ring-2 focus:ring-inset focus:ring-white"
            >
              <span class="sr-only">Open main menu</span>
              <MenuIcon v-if="!open" class="block h-6 w-6" aria-hidden="true" />
              <XIcon v-else class="block h-6 w-6" aria-hidden="true" />
            </DisclosureButton>
          </div>
          <div
            class="flex-1 flex items-center justify-center sm:items-stretch sm:justify-start"
          >
            <div class="hidden sm:block sm:ml-6">
              <div class="flex space-x-4">
                <router-link
                  v-for="item in navigation"
                  :key="item.name"
                  :to="{ name: item.href }"
                  :class="[
                    item.current
                      ? 'bg-gray-900 text-white'
                      : 'text-gray-300 hover:bg-gray-700 hover:text-white',
                    'px-3 py-2 rounded-md text-sm font-medium',
                  ]"
                  :aria-current="item.current ? 'page' : undefined"
                  >{{ item.name }}
                </router-link>
              </div>
            </div>
          </div>
          <div
            class="absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0"
          >
            <!-- Cart dropdown -->
            <Menu as="div" class="ml-4 relative">
              <div v-if="logged" style="display: inline-flex;">
                <Popover>
                  <PopoverButton>
                    <button
                      v-if="cart"
                      class="text-white text-gray-300 bg-gray-900 hover:bg-gray-700 hover:text-white x-3 py-2 rounded-md text-sm font-medium px-3 py-2 rounded-md text-sm font-medium "
                      title="Mon panier"
                    >
                      <ShoppingCartIcon
                        class="h-6 w-6"
                        aria-hidden="true"
                        style="display: inline-flex"
                      />
                      &nbsp;{{ counter_cart }}
                    </button>
                  </PopoverButton>

                  <PopoverPanel
                    class="absolute z-10 w-screen max-w-sm px-4 mt-8 transform -translate-x-1/2 left-1/2 sm:px-0 lg:max-w-3l rounded"
                    style="width: 200%; max-height:400px; overflow-y:scroll"
                  >
                    <div
                      class="overflow-hidden rounded-lg shadow-lg ring-1 ring-black ring-opacity-5"
                    >
                      <div
                        class="relative grid gap-8 p-7 lg:grid-cols-1"
                        style="background: white"
                      >
                        <h2 style="color:black">Panier</h2>
                        <div
                          v-for="item in cart"
                          :key="item.name"
                          class="flex items-center "
                          style="width: 100%"
                        >
                          <div class="flex flex-wrap md:items-center mb-5">
                            <div class="md:w-2/4">
                              <img
                                style="width: 100%;"
                                :src="item.image_link"
                              />
                            </div>
                            <div class="md:w-2/4" style="padding-left: 5%">
                              <p
                                class="text-sm font-medium text-white text-gray-300 gradient rounded-md p-1"
                                style="float: right"
                              >
                                {{ item.photo_item.format.price }}€
                              </p>
                              <p
                                class="text-sm font-medium text-gray-900"
                                style="float: left"
                              >
                                {{ item.image_name }}
                              </p>
                              <br />
                              <p
                                class="text-sm font-medium text-gray-900"
                                style="float: left"
                              >
                                {{ item.photo_item.format.label }}
                              </p>
                              <br />
                              <p
                                class="text-sm text-gray-500"
                                style="float:right"
                              >
                                quantité : {{ item.quantity }}
                              </p>
                            </div>
                          </div>
                        </div>
                        <div class="flex flex-wrap md:items-center mb-5">
                          <router-link
                            :to="{ name: 'cart' }"
                            class="bg-gray-900 text-white text-gray-300 hover:bg-gray-700 hover:text-white px-3 py-2 rounded-md text-sm font-medium"
                            >Voir le panier
                          </router-link>
                        </div>
                      </div>
                    </div>
                  </PopoverPanel>
                </Popover>

                <router-link
                  :to="{ name: 'profile' }"
                  class="text-white text-gray-300 hover:text-white x-3 py-2 rounded-md text-sm font-medium px-3 py-2 rounded-md text-sm font-medium "
                  style="background: none;"
                  title="Mon profil"
                >
                  <UserCircleIcon class="h-7 w-7" aria-hidden="true" />
                </router-link>

                <button
                  @click="logout()"
                  class="text-white text-gray-300 hover:text-white x-3 py-2 rounded-md text-sm font-medium px-3 py-2 rounded-md text-sm font-medium "
                  title="Déconnexion"
                >
                  <LogoutIcon class="h-6 w-6" aria-hidden="true" />
                </button>
              </div>

              <router-link
                v-else
                :to="{ name: 'login' }"
                class="bg-gray-900 text-white text-gray-300 hover:bg-gray-700 hover:text-white x-3 py-2 rounded-md text-sm font-medium px-3 py-2 rounded-md text-sm font-medium "
              >
                Connexion
              </router-link>
            </Menu>
          </div>
        </div>
      </div>

      <DisclosurePanel class="sm:hidden">
        <div class="px-2 pt-2 pb-3 space-y-1">
          <router-link
            v-for="item in navigation"
            :key="item.name"
            :to="{ name: 'home' }"
            :class="[
              item.current
                ? 'bg-gray-900 text-white'
                : 'text-gray-300 hover:bg-gray-700 hover:text-white',
              'block px-3 py-2 rounded-md text-base font-medium',
            ]"
            :aria-current="item.current ? 'page' : undefined"
            >{{ item.name }}
          </router-link>
        </div>
      </DisclosurePanel>
    </Disclosure>
  </div>
</template>

<script>
import axios from "../api/config";
import { ref } from "vue";
import {
  Disclosure,
  DisclosureButton,
  DisclosurePanel,
  Menu,
  Popover,
  PopoverButton,
  PopoverPanel,
} from "@headlessui/vue";
import {
  UserCircleIcon,
  ShoppingCartIcon,
  MenuIcon,
  XIcon,
  LogoutIcon,
} from "@heroicons/vue/outline";
import emitter from "tiny-emitter/instance";

const navigation = [
  { name: "Accueil", href: "home", current: true },
  { name: "Photos", href: "pictures", current: false },
  { name: "Albums", href: "albums", current: false },
];

export default {
  components: {
    Disclosure,
    DisclosureButton,
    DisclosurePanel,
    Menu,
    UserCircleIcon,
    ShoppingCartIcon,
    LogoutIcon,
    MenuIcon,
    XIcon,
    Popover,
    PopoverButton,
    PopoverPanel,
  },
  setup() {
    const open = ref(false);
    return {
      navigation,
      open,
    };
  },
  data() {
    return {
      logged: false,
      cart: false,
      error: null,
      counter_cart: 0,
    };
  },
  watch: {
    $route() {
      this.logged = localStorage.getItem("is_logged") == "true" ? true : false;
    },
  },
  methods: {
    logout() {
      axios
        .get("http://localhost:8888/photos_api/api/logout")
        .then((res) => {
          if (res.data.result) {
            localStorage.clear();
            if (this.$route.name != "home") {
              return this.$router.push({ name: "home" });
            }
          } else {
            this.error = res.data.error;
          }
          this.$router.go(0);
        })
        .catch(() => {
          this.error = "Une erreur est survenue";
        });
    },
    setCart() {
      this.cart =
        localStorage.getItem("cart") != null
          ? JSON.parse(localStorage.getItem("cart"))
          : {};
      this.counter_cart = this.cart.length;
    },
  },
  mounted: function() {
    emitter.on("set_cart", () => {
      this.setCart();
    });
    this.setCart();
  },
};
</script>
